	
#define COPYRIGHT "GNUpyright (G)2001 Michael Polk, Arachne Labs, http://gnu.arachne.cz/"

#define VERSION "0.6"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
 
#define do while(1)
#define L 31415
#define ISOLATIN2DEF "\
[ /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/space /exclam /quotedbl /numbersign /dollar /percent /ampersand /quoteright\n\
/parenleft /parenright /asterisk /plus /comma /minus /period /slash\n\
/zero /one /two /three /four /five /six /seven\n\
/eight /nine /colon /semicolon /less /equal /greater /question\n\
% 100\n\
/at /A /B /C /D /E /F /G\n\
/H /I /J /K /L /M /N /O\n\
/P /Q /R /S /T /U /V /W\n\
/X /Y /Z /bracketleft /backslash /bracketright /asciicircum /underscore\n\
/quoteleft /a /b /c /d /e /f /g\n\
/h /i /j /k /l /m /n /o\n\
/p /q /r /s /t /u /v /w\n\
/x /y /z /braceleft /bar /braceright /asciitilde /.notdef\n\
% 200\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n\
/space /Aogonek /breve /Lslash /currency /Lcaron /Sacute /section\n\
/dieresis /Scaron /Scedilla /Tcaron /Zacute /hyphen /Zcaron /Zdotaccent\n\
/degree /aogonek /ogonek /lslash /acute /lcaron /sacute /caron\n\
/cedilla /scaron /scedilla /tcaron /zacute /hungarumlaut /zcaron /zdotaccent\n\
% 300\n\
/Racute /Aacute /Acircumflex /Abreve /Adieresis /Lacute /Cacute /Ccedilla\n\
/Ccaron /Eacute /Eogonek /Edieresis /Ecaron /Iacute /Icircumflex /Dcaron\n\
/Dbar /Nacute /Ncaron /Oacute /Ocircumflex /Ohungarumlaut /Odieresis /multiply\n\
/Rcaron /Uring /Uacute /Uhungarumlaut /Udieresis /Yacute /Tcedilla /germandbls\n\
/racute /aacute /acircumflex /abreve /adieresis /lacute /cacute /ccedilla\n\
/ccaron /eacute /eogonek /edieresis /ecaron /iacute /icircumflex /dcaron\n\
/dbar /nacute /ncaron /oacute /ocircumflex /ohungarumlaut /odieresis /divide\n\
/rcaron /uring /uacute /uhungarumlaut /udieresis /yacute /tcedilla /dotaccent\n\
] /isolatin2encoding exch def"

char *transcode[]={
"\\376\\004","",
"\\330\\002","",
"\\101\\001","",
"\\244\\000","",
"\\075\\001","",
"\\132\\001","",
"\\247\\000","",
"\\250\\000","",
"\\140\\001","",
"\\136\\001","",
"\\144\\001","",
"\\171\\001","",
"\\255\\000","",
"\\175\\001","",
"\\173\\001","",
"\\260\\000","",
"\\005\\001","",
"\\333\\002","",
"\\102\\001","",
"\\264\\000","",
"\\076\\001","",
"\\133\\001","",
"\\307\\002","",
"\\270\\000","",
"\\141\\001","",
"\\137\\001","",
"\\145\\001","",
"\\172\\001","",
"\\335\\002","",
"\\176\\001","",
"\\174\\001","",
"\\124\\001","",
"\\301\\000","",
"\\302\\000","",
"\\002\\001","",
"\\304\\000","",
"\\071\\001","",
"\\006\\001","",
"\\307\\000","",
"\\014\\001","",
"\\311\\000","",
"\\030\\001","",
"\\313\\000","",
"\\032\\001","",
"\\315\\000","",
"\\316\\000","",
"\\016\\001","",
"\\020\\001","",
"\\103\\001","",
"\\107\\001","",
"\\323\\000","",
"\\324\\000","",
"\\120\\001","",
"\\326\\000","",
"\\327\\000","",
"\\130\\001","",
"\\156\\001","",
"\\332\\000","",
"\\160\\001","",
"\\334\\000","",
"\\335\\000","",
"\\142\\001","",
"\\337\\000","",
"\\125\\001","",
"\\341\\000","",
"\\342\\000","",
"\\003\\001","",
"\\344\\000","",
"\\072\\001","",
"\\007\\001","",
"\\347\\000","",
"\\015\\001","",
"\\351\\000","",
"\\031\\001","",
"\\353\\000","",
"\\033\\001","",
"\\355\\000","",
"\\356\\000","",
"\\017\\001","",
"\\021\\001","",
"\\104\\001","",
"\\110\\001","",
"\\363\\000","",
"\\364\\000","",
"\\121\\001","",
"\\366\\000","",
"\\367\\000","",
"\\131\\001","",
"\\157\\001","",
"\\372\\000","",
"\\161\\001","",
"\\374\\000","",
"\\375\\000","",
"\\143\\001","",
"\\331\\002","",
"\\134\\000","\\\\",
"\0","\0"};

int main(int argc, char **argv)
{
 char l[L], *p, *substfont=NULL;
 int ll,i=1,h=0,mozilla=0, allowcut=0;
 float up=0, lw=0;

 while(i<argc)
 {
  if(argv[i][0]=='-')
   switch(tolower(argv[i][1]))
   {
    case 'n': if(i+1<argc)
               up=atof(argv[i+1]);
              break;
    case 'd': if(i+1<argc)
               lw=atof(argv[i+1]);
              break;
    case 'f': if(i+1<argc)
               substfont=argv[i+1];
              break;
     default: printf("Poeti V%s\n%s\n",VERSION,COPYRIGHT);
              printf("Syntax:\npocesti [-n upper limit (pt)] [-d lower limit (pt)] [-f font substitution ]\n");
              exit(0);
   }
  i++;
 }

 do
 {
  fgets(l,L,stdin); 
  if(feof(stdin))
   exit(0);
  if(h==0) //----------------------------- header was not yet parsed...
  {
   if(!strcmp(l,"%%BeginProlog\n"))
   {
    h=1;
    printf("%s",l);
    puts(ISOLATIN2DEF);
   }
   else
   if(!strcmp(l,"%%Creator: Mozilla (NetScape) HTML->PS\n"))
    mozilla=1;
   else
   if(!strcmp(l,"% MozillaCharsetName: iso-8859-1\n"))
    mozilla=5;
   else
   if(strncmp(l,"%%Title:",8)) //"!=", %%Title cannot contain 8bit entities
    printf("%s",l);
  }
  else //------------------------------- header was parsed, let continue
  if(mozilla)
  {
   if(strstr(l,"/Encoding"))
   {
    p=strstr(l,"1encoding");
    if(p)
     *p='2'; 
    printf("%s",l);
   }
   else if(!strcmp(l,"%%EndProlog\n"))
   { 
    printf("%s",l);
    allowcut=1;
   }
   else if(strstr(l,"initclip"))
   { 
    printf("%s",l);
    allowcut=0;
   }
   else if(strstr(l,"clip"))
   { 
    printf("%s",l);
    allowcut=1;
   }
   else if ((up!=0 || lw!=0) && strstr(l," moveto") && allowcut)
   {
    float x,y;
    sscanf(l,"%f %f",&x,&y);
    if(up!=0 && y>up)
    {
     y+=10000;
     sprintf(l,"%.1f %.1f moveto\n",x,y);
    }
    else if(lw!=0 && y<lw)
    {
     y-=10000;
     sprintf(l,"%.1f %.1f moveto\n",x,y);
    }
    printf("%s",l);
   }
   else if (substfont && strstr(l," findfont"))
   {
    if(strstr(l,"/Times-Roman "))
     sprintf(l,"    /%s findfont\n",substfont);
    else
    if(strstr(l,"/Times-Bold "))
     sprintf(l,"    /%s-Bold findfont\n",substfont);
    else
    if(strstr(l,"/Times-Italic "))
     sprintf(l,"    /%s-Oblique findfont\n",substfont);
    else
    if(strstr(l,"/Times-BoldItalic "))
     sprintf(l,"    /%s-BoldOblique findfont\n",substfont);
    
    printf("%s",l);
   }
   else if(mozilla==5 && strchr(l,'\\'))
   {
    p=l;
    ll=strlen(p);
    while(*p)
    {
     if( *p=='\\')
     {
      if(ll>1 && p[1]=='\\')
      {
       printf("\\\\");
       p+=2;
       ll-=2;
      }
      else
      if(ll>=8)
      {
       i=0;
       while(transcode[i])
       {
        if(!strncmp(p,transcode[i],8))
        {
         p+=8;
         ll-=8;
         printf(transcode[i+1]);
         goto cont;
        }
        i+=2;
       }
      }
      
      if(ll>=4)
      {
       if( strncmp(p,"\\000",4) )
       {
        int c=(p[3]-'0')+(p[2]-'0')*8+(p[1]-'0')*64;
        if(c>31 && c!='%' && c!='(' && c!=')') //v0.3 bug fix 
         putchar(c);
        else
         printf("\\%c%c%c",p[1],p[2],p[3]);
       }
       p+=4;
       ll-=4;
      }
      else
      {
       putchar(*p);
       p++;
       ll--;
      }
     }
     else
     if(ll>=11 && strchr(l,')') && !strncmp(p,"unicodeshow",11) )
     {
      printf("show");
      p+=11;
      ll-=11;
     }
     else
     {
      putchar(*p);
      p++;
      ll--;
     }
     cont:;
    }
   }
   else
    printf("%s",l);
  }
  else
   printf("%s",l);
 }

 return 0;
}
